var roleDispatcher = require('role_dispatcher');

module.exports.loop = function () {
    
    for(var name in Memory.creeps) {
        if(!Game.creeps[name]) {
            delete Memory.creeps[name];
        }
    }

	roleDispatcher.spawnCreeps(Game.spawns['Moscow']);
    

    if(Game.spawns['Moscow'].spawning) {
        var spawningCreep = Game.creeps[Game.spawns['Moscow'].spawning.name];
        Game.spawns['Moscow'].room.visual.text(
            '🛠️' + spawningCreep.memory.role,
            Game.spawns['Moscow'].pos.x + 1,
            Game.spawns['Moscow'].pos.y,
            {align: 'left', opacity: 0.8});
    }

    for(var name in Game.creeps) {
        var creep = Game.creeps[name];
		roleDispatcher.runRole(creep);
    }
}
